package com.citygis.impl;

import com.alibaba.fastjson.JSONArray;
import com.alibaba.fastjson.JSONException;
import com.alibaba.fastjson.JSONObject;
import com.citygis.mapper.MapperBySql;
import org.springframework.stereotype.Component;

import javax.annotation.Resource;
import java.sql.*;
import java.text.DateFormat;
import java.util.Date;
import java.util.*;


@Component
public class DBUtilSqlServer {
    @Resource
    MapperBySql mapperBySql;


    public static String cfn = "";
    public static String url = "";
    public static String username = "";
    public static String password = "";
    private static Boolean showMessage = false;
    private static String currentpageindex = "1";
    public static String ConnectionExceptionMessage = "";

    public String UpadteDataBase(String SQL) {
//			currentpageindex = "1";
        Connection conn = null;
        Statement stmt = null;
        String ReturnStr = "";
        try {
//				   showMessage("数据更新语句:\n"+SQL);
//             conn=getConnection();
//            if(conn == null) {
//                return  GetReturnStr("Fault",ConnectionExceptionMessage,"0","[{}]","0");
//            }
//            conn.setAutoCommit(false);//将自动提交关闭
//            stmt = conn.createStatement();
            int result = mapperBySql.updateBySql(SQL);
            //   conn.commit();
            if (result > 0) {
//					   ReturnStr = GetReturnStr("Success","数据库操作成功！",String.valueOf(result.length),"[{}]","0");
                ReturnStr = GetReturnStr("Success", "数据库操作成功！", String.valueOf(result), "[{}]", "0");
//					   showMessage("数据更新成功！！！！！！！！！！！"+ReturnStr);
            } else {
                ReturnStr = GetReturnStr("Fault", "更新操作，此数据不存在，请先插入之后再做更新！", String.valueOf(result), "[{}]", "0");
            }
        } catch (Exception e) {
            e.printStackTrace();
            //     conn.rollback();
            showMessage(SQL + "\n数据更新失败！！！！！！ 失败原因：" + e.getMessage());
            ReturnStr = GetReturnStr("Fault",e.getCause().toString().replaceAll("\\\\","\\\\\\\\").replaceAll("'"," "), "0", "[{}]", "0");
        } finally {
            if (stmt != null) {
                try {
                    stmt.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                stmt = null;
            }

            if (conn != null) {
                try {
                    conn.setAutoCommit(true);
                    conn.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                conn = null;
            }
        }
        return ReturnStr;
    }

    public String UpdateBatch(String SQL) {
        Connection conn = null;
        Statement stmt = null;
        String ReturnStr = "";
        try {
            // conn=getConnection();
            if (conn == null) {
                return GetReturnStr("Fault", ConnectionExceptionMessage, "0", "[{}]", "0");
            }
            conn.setAutoCommit(false);//将自动提交关闭
            stmt = conn.createStatement();
            for (int i = 0; i < SQL.split(";").length; i++) {
                stmt.addBatch(SQL.split(";")[i]);
            }
            int result = mapperBySql.updateBySql(SQL);//mapper.updateBySql(SQL);
            conn.commit();
            if (result > 0) {
                ReturnStr = GetReturnStr("Success", "数据库操作成功！", String.valueOf(result), "[{}]", "0");
            }
        } catch (Exception e) {
            e.printStackTrace();
            try {
                conn.rollback();
            } catch (SQLException e1) {
                e1.printStackTrace();
            }
            ReturnStr = GetReturnStr("Fault", e.getMessage().replaceAll("'"," ").replaceAll("\\\\","\\\\\\\\"), "0", "[{}]", "0");
            showMessage(SQL + "\nUpadteDataBaseNoMessage失败！！！！： 失败原因：" + e.getMessage());
        } finally {
            if (stmt != null) {
                try {
                    stmt.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                stmt = null;
            }

            if (conn != null) {
                try {
                    conn.setAutoCommit(true);
                    conn.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                conn = null;
            }
        }
        return ReturnStr;
    }

    public String UpadteDataBaseNoMessage(String SQL) {
        Connection conn = null;
        Statement stmt = null;
//			currentpageindex = "1";
        String ReturnStr = "";
        try {
            // conn=getConnection();
            if (conn == null) {
                return GetReturnStr("Fault", ConnectionExceptionMessage, "0", "[{}]", "0");
            }
            stmt = conn.createStatement();
            int result = mapperBySql.updateBySql(SQL);
            if (result > 0) {
                ReturnStr = GetReturnStr("Success", "数据库操作成功！", String.valueOf(result), "[{}]", "0");
            }
        } catch (Exception e) {
            e.printStackTrace();
            ReturnStr = GetReturnStr("Fault", e.getMessage().replaceAll("'"," ").replaceAll("\\\\","\\\\\\\\"), "0", "[{}]", "0");
            showMessage(SQL + "\nUpadteDataBaseNoMessage失败！！！！： 失败原因：" + e.getMessage());
        } finally {
            if (stmt != null) {
                try {
                    stmt.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                stmt = null;
            }

            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                conn = null;
            }
        }
        return ReturnStr;
    }

    public String QueryDataBase(String sql) {
//	    	currentpageindex = "1";
        Connection conn = null;
        PreparedStatement statement = null;
        ResultSet res = null;
        //showMessage("数据查询语句:\n"+sql);
        try {
//            // conn = getConnection();
//            if(conn == null) {
//
//                return GetReturnStr("Fault",ConnectionExceptionMessage,"0","[{}]","0");
//            }
//            statement = conn.prepareStatement(sql);
//            res = statement.executeQuery();
            List<LinkedHashMap<String, Object>> dateBySql = mapperBySql.getDateBySql(sql);
            String returnStr = resultSetToJson(dateBySql, "1");


            //showMessage("数据查询结果：\n"+returnStr);
            return returnStr;
        } catch (Exception e) {
            e.printStackTrace();
            showMessage(sql + "\n数据查询QueryDataBase失败！！！！： 失败原因：" + e.getMessage());
            String ReturnStr = GetReturnStr("Fault", e.getMessage().replaceAll("'"," ").replaceAll("\\\\","\\\\\\\\"), "0", "[{}]", "0");

            return ReturnStr;
        } finally {
            if (statement != null) {
                try {
                    statement.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                statement = null;
            }
            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                conn = null;
            }
            if (res != null) {
                try {
                    res.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                res = null;
            }
        }
    }

    //key主键
    public static String QueryDataBaseByPage(String sql, String pageIndex, String pageSize) {
        currentpageindex = pageIndex;
        String searchPage = pageIndex;
        Connection conn = null;
        PreparedStatement statement = null;
        ResultSet res = null;
        ResultSet restotal = null;
        //showMessage("数据查询语句:\n"+sql);
        String sqlStr = null;
        try {
            sqlStr = "select top " + pageSize + " * " +
                    "from (select row_number() over(order by sortnumber) as rownumber,* " +
                    "from (select *,0 as sortnumber from (" + sql + ") bb)aa) temp_row where rownumber>(" + searchPage + "-1)*" + pageSize + ";";
//		    	showMessage("数据查询语句:\n"+sqlStr);
            // conn = getConnection();
            if (conn == null) {
                return GetReturnStr("Fault", ConnectionExceptionMessage, "0", "[{}]", "0");
            }
            statement = conn.prepareStatement("select COUNT(*) as total from (" + sql + ") aa");
            restotal = statement.executeQuery();
            String TotalCount = resultGetTotal(restotal);

            // statement = getConnection().prepareStatement(sqlStr);
            res = statement.executeQuery();

            String returnStr = resultSetToJson(res, TotalCount, currentpageindex);
//		    	 String returnStr = resultSetToJson(res);
//		    	 showMessage("数据查询结果：\n"+returnStr);
            return returnStr;
        } catch (Exception e) {
            e.printStackTrace();
            showMessage(sqlStr + "\n数据查询QueryDataBaseByPage失败！！！！： 失败原因：" + e.getMessage());
            return GetReturnStr("Fault", "数据查询失败！！！！：\n 失败原因：" + e.getMessage().replaceAll("'"," ").replaceAll("\\\\","\\\\\\\\"), "0", "[{}]", "0");
        } finally {
            if (statement != null) {
                try {
                    statement.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                statement = null;
            }
            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                conn = null;
            }
            if (res != null) {
                try {
                    res.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                res = null;
            }
        }
    }


    public static String QueryDataBaseByPageobj(String sql, String pageIndex, String pageSize) {
        currentpageindex = pageIndex;
        String searchPage = pageIndex;
        Connection conn = null;
        PreparedStatement statement = null;
        ResultSet res = null;
        ResultSet restotal = null;
        //showMessage("数据查询语句:\n"+sql);
        String sqlStr = null;
        try {
            sqlStr = "select top " + pageSize + " * " +
                    "from (select row_number() over(order by sortnumber) as rownumber,* " +
                    "from (select *,0 as sortnumber from (" + sql + ") bb)aa) temp_row where rownumber>(" + searchPage + "-1)*" + pageSize + ";";
//		    	showMessage("数据查询语句:\n"+sqlStr);
            // conn = getConnection();
            if (conn == null) {
                return GetReturnStr("Fault", ConnectionExceptionMessage, "0", "[{}]", "0");
            }
            statement = conn.prepareStatement("select COUNT(*) as total from (" + sql + ") aa");
            restotal = statement.executeQuery();
            String TotalCount = resultGetTotal(restotal);

            // statement = getConnection().prepareStatement(sqlStr);
            res = statement.executeQuery();

            String returnStr = resultSetToJsonobj(res, TotalCount, currentpageindex);
//		    	 String returnStr = resultSetToJson(res);
//		    	 showMessage("数据查询结果：\n"+returnStr);
            return returnStr;
        } catch (Exception e) {
            e.printStackTrace();
            showMessage(sqlStr + "\n数据查询QueryDataBaseByPage失败！！！！： 失败原因：" + e.getMessage());
            return GetReturnStr("Fault", "数据查询失败！！！！：\n 失败原因：" + e.getMessage().replaceAll("'"," ").replaceAll("\\\\","\\\\\\\\"), "0", "[{}]", "0");
        } finally {
            if (statement != null) {
                try {
                    statement.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                statement = null;
            }
            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                conn = null;
            }
            if (res != null) {
                try {
                    res.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                res = null;
            }
        }
    }


    //key主键
    public static String QueryDataBaseByPageO(String sql, String pageIndex, String pageSize, String key) {
        currentpageindex = pageIndex;
        String searchPage = pageIndex;
        Connection conn = null;
        PreparedStatement statement = null;
        ResultSet res = null;
        ResultSet restotal = null;
//		   	showMessage("数据查询语句:\n"+sql);
        String sqlStr = null;
        try {
            sqlStr = "select top " + pageSize + " * " +
                    "from (select row_number() over(order by " + key + ") as rownumber,* " +
                    "from  (" + sql + ")aa) temp_row where rownumber>(" + searchPage + "-1)*" + pageSize + ";";
//		    	showMessage("数据查询语句:\n"+sqlStr);
            // conn = getConnection();
            if (conn == null) {

                return GetReturnStr("Fault", ConnectionExceptionMessage, "0", "[{}]", "0");
            }
            statement = conn.prepareStatement("select COUNT(*) as total from (" + sql + ") aa");
            restotal = statement.executeQuery();
            String TotalCount = resultGetTotal(restotal);

            // statement = getConnection().prepareStatement(sqlStr);
            res = statement.executeQuery();
            String returnStr = resultSetToJson(res, TotalCount, currentpageindex);
//		    	 String returnStr = resultSetToJson(res);
//		    	 showMessage("数据查询结果：\n"+returnStr);
            return returnStr;
        } catch (Exception e) {
            e.printStackTrace();
            showMessage(sqlStr + "\n数据查询QueryDataBaseByPageO失败！！！！： 失败原因：" + e.getMessage());
            return GetReturnStr("Fault", "数据查询失败！！！！：\n 失败原因：" + e.getMessage().replaceAll("'"," ").replaceAll("\\\\","\\\\\\\\"), "0", "[{}]", "0");
        } finally {
            if (statement != null) {
                try {
                    statement.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                statement = null;
            }
            if (conn != null) {
                try {
                    conn.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                conn = null;
            }
            if (res != null) {
                try {
                    res.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                res = null;
            }
            if (restotal != null) {
                try {
                    restotal.close();
                } catch (SQLException e) {
                    e.printStackTrace();
                }
                restotal = null;
            }
        }
    }

    private static long start;
//	    public static Connection getConnection(){
//	    	ProxySelector ps=ProxySelector.getDefault(); //获取网络代理
//	    	ProxySelector.setDefault(null);	 //关闭网络代理
//	    	if(cfn == "" || url == "" || username == "" ||password == ""){
//	    		 new PropertiesCon();
//	    	}
//	    	//showMessage("数据库连接字符串:\n连接驱动："+cfn+"\n服务器地址："+url+"\n用户名:"+username+"\n密码："+password);
//	    	Connection con = null;
//		   	try {
//		   		start=System.currentTimeMillis();
////		   		con = DBConn.getConnection();
//				Class.forName(cfn);
//				con = DriverManager.getConnection(url,username,password);
//				long end=(System.currentTimeMillis()-start)/1000;
////		   		System.out.println("获取连接的时间:"+end+"秒");
//				//showMessage("数据库连接成功！！！！！！！！！！！");
//			} catch (Exception e) {
//				e.printStackTrace();
//				ConnectionExceptionMessage = e.getMessage();
//				showMessage("----------------数据库连接失败！\n失败原因："+e.getMessage());
//			}finally{
//				ProxySelector.setDefault(ps);//还原网络代理  不还原总会出问题
//			}
//	        return con;
//	    }

    public static String resultGetTotal(ResultSet rs) throws SQLException {
        String ReturnStr = "";
        try {
            while (rs.next()) {
                ReturnStr = rs.getString(1);
            }
        } catch (Exception e) {
            // TODO: handle exception
        }
        return ReturnStr;
    }

    public static String resultSetToJson(ResultSet rs, String total, String curPageIndex) throws SQLException, JSONException {
        // json数组
        JSONArray array = new JSONArray();
        // 获取列数
        ResultSetMetaData metaData = rs.getMetaData();
        int columnCount = metaData.getColumnCount();
        int count = 0;
        // 遍历ResultSet中的每条数据
        while (rs.next()) {
            JSONObject jsonObj = new JSONObject();

            // 遍历每一列
            for (int i = 1; i <= columnCount; i++) {
                String columnName = metaData.getColumnLabel(i);
                String value = rs.getString(columnName);
                if (value == null) {
                    value = "";
                }
                jsonObj.put(columnName, value);
            }
            array.add(jsonObj);
            count++;
        }
        String ReturnStr = GetReturnStr("Success", "", total, array.toString(), curPageIndex);
        return ReturnStr;
    }

    public static String resultSetToJsonobj(ResultSet rs, String total, String curPageIndex) throws SQLException, JSONException {
        // json数组
        JSONArray array = new JSONArray();
        // 获取列数
        ResultSetMetaData metaData = rs.getMetaData();
        int columnCount = metaData.getColumnCount();
        int count = 0;
        // 遍历ResultSet中的每条数据
        while (rs.next()) {
            JSONObject jsonObj = new JSONObject();

            // 遍历每一列
            for (int i = 1; i <= columnCount; i++) {
                String columnName = metaData.getColumnLabel(i);
                String value = rs.getString(columnName);
                if (value == null) {
                    value = "";
                }
                jsonObj.put(columnName, value);
            }
            array.add(jsonObj);
            count++;
        }
        String ReturnStr = GetReturnStrobj("Success", "", total, array.toString(), curPageIndex);
        return ReturnStr;
    }

    public static String resultSetToJson(List<LinkedHashMap<String, Object>> rs, String curPageIndex) throws SQLException, JSONException {
        LinkedHashMap<String, Object> linkedHashMap = rs.get(0);

        JSONArray array = new JSONArray();
        JSONObject jsonObj = new JSONObject();
        ListIterator<Map.Entry<String, Object>> i = new ArrayList<Map.Entry<String, Object>>(linkedHashMap.entrySet()).listIterator(linkedHashMap.size());
        while (i.hasPrevious()) {
            Map.Entry<String, Object> entry = i.previous();
            jsonObj.put(entry.getKey(), entry.getValue());
        }
        array.add(jsonObj);


        String ReturnStr = GetReturnStr("Success", "", String.valueOf(array.size()), array.toString(), curPageIndex);
        return ReturnStr;
    }

    public static String resultSetToJsonobj(ResultSet rs, String curPageIndex) throws SQLException, JSONException {
        // json数组
        JSONArray array = new JSONArray();
        // 获取列数
        ResultSetMetaData metaData = rs.getMetaData();
        int columnCount = metaData.getColumnCount();
        int count = 0;
        // 遍历ResultSet中的每条数据
        while (rs.next()) {
            JSONObject jsonObj = new JSONObject();

            // 遍历每一列
            for (int i = 1; i <= columnCount; i++) {
                String columnName = metaData.getColumnLabel(i);
                String value = rs.getString(columnName);
                if (value == null) {
                    value = "";
                }
                jsonObj.put(columnName, value);
            }
            array.add(jsonObj);
            count++;
        }
        String ReturnStr = GetReturnStrobj("Success", "", String.valueOf(array.size()), array.toString(), curPageIndex);
        return ReturnStr;
    }


    public static String GetReturnStr(String Success, String message, String Count, String QueryData, String currPageIndex) {
        String ReturnStr =  //"<?xml version=\"1.0\" encoding=\"UTF-8\"?><string xmlns=\"http://tempuri.org/\">" +
                "[{\"IsSuc\":\"" + Success + "\",\"Msg\":\"" + message.replaceAll("\"", " ") + "\",\"AllCount\":\"" + Count + "\",\"pageIndex\":\"" + currPageIndex + "\",\"CurrCount\":\"1\",\"pkid\":\"\",\"data\":" + QueryData + "}]";
        // "</string>";
        long end = (System.currentTimeMillis() - start) / 1000;
//	   		System.out.println("数据总查询时间:"+end+"秒");
        return ReturnStr;
    }

    public static String GetReturnStrobj(String Success, String message, String Count, String QueryData, String currPageIndex) {
        String ReturnStr =  //"<?xml version=\"1.0\" encoding=\"UTF-8\"?><string xmlns=\"http://tempuri.org/\">" +
                "{\"IsSuc\":\"" + Success + "\",\"Msg\":\"" + message.replaceAll("\"", " ") + "\",\"AllCount\":\"" + Count + "\",\"pageIndex\":\"" + currPageIndex + "\",\"CurrCount\":\"1\",\"pkid\":\"\",\"data\":" + QueryData + "}";
        // "</string>";
        long end = (System.currentTimeMillis() - start) / 1000;
//	   		System.out.println("数据总查询时间:"+end+"秒");
        return ReturnStr;
    }

    public static void showMessage(String messageStr) {
        DateFormat ddf = DateFormat.getDateTimeInstance();

        if (showMessage) {
            System.out.println("时间：" + ddf.format(new Date()) + messageStr);
        }
    }
}
